#include "AppController.h"
#include <AppKit/AppKit.h>
#include "NSView+Snapshot.h"

@implementation AppController
- (void) applicationWillFinishLaunching: (NSNotification *) not
{
   /* Create Menu */
   NSMenu *menu;
   NSMenu *info;

   menu = [NSMenu new];
   [menu addItemWithTitle: @"Info"
                   action: NULL
            keyEquivalent: @""];
   [menu addItemWithTitle: @"Hide"
                   action: @selector(hide:)
            keyEquivalent: @"h"];
   [menu addItemWithTitle: @"Quit"
                   action: @selector(terminate:)
            keyEquivalent: @"q"];

   info = [NSMenu new];
   [info addItemWithTitle: @"Info Panel..."
                   action: @selector(orderFrontStandardInfoPanel:)
            keyEquivalent: @""];
   [info addItemWithTitle: @"Preferences"
                   action: NULL
            keyEquivalent: @""];
   [info addItemWithTitle: @"Help"
                   action: @selector (orderFrontHelpPanel:)
            keyEquivalent: @"?"];

   [menu setSubmenu: info
            forItem: [menu itemWithTitle:@"Info"]];
   RELEASE(info);

   [NSApp setMainMenu:menu];
   RELEASE(menu);

   /* Create Window */
   window = [[NSWindow alloc] initWithContentRect: NSMakeRect(300, 300, 200, 100)
                                        styleMask: (NSTitledWindowMask |
                                                    NSMiniaturizableWindowMask |
                                                    NSResizableWindowMask)
                                          backing: NSBackingStoreBuffered
                                            defer: YES];
   [window setTitle: @"Hello World"];



   NSButton *button1 = [[NSButton alloc] initWithFrame: NSMakeRect(30, 30, 125, 30)];
   [[window contentView] addSubview: button1];
   RELEASE(button1);

   NSButton *button2 = [[NSButton alloc] initWithFrame: NSMakeRect(130, 30, 125, 30)];
   [[window contentView] addSubview: button2];
   RELEASE(button2);

    NSView *v = [[[NSView alloc] initWithFrame:NSMakeRect(0,0, 125, 13)] autorelease];
    NSLevelIndicator *ind = [[[NSLevelIndicator alloc] initWithFrame:NSMakeRect(0,0, 125, 13)] autorelease];
    [ind setMaxValue:1];
    [ind setFloatValue:0.3];
    [v addSubview:ind];
    [button1 setImage:[v snapshotIncludingSubviews]];
    
    
    
    
    NSLevelIndicator *li = [[[NSLevelIndicator alloc] initWithFrame:NSMakeRect(0,0, 125, 13)] autorelease];
    [li setMaxValue:3];
    [li setFloatValue:0.2];
    [button2 setImage:[li snapshotFromRect:NSMakeRect(0,0, 125, 13)]];
   
}

- (void) applicationDidFinishLaunching: (NSNotification *) not
{
   [window makeKeyAndOrderFront: self];
}

- (void) dealloc
{
  RELEASE(window);
  [super dealloc];
}

@end
